<?php
require_once("cwfUI.inc.php");

class DbAdminFirstLoginUI extends cwfUI {
  protected static $dataClass = "DbAdmin";
  
  public function __construct(DbConnection $DB) {
    parent::__construct();
    $this->initialize();
    
    if(isset($_POST['kdb_save']) && $_POST['kdb_save']) {
      $this->data->fromArray($_POST);
      $this->data->changePW($DB);
      $this->header .= "  <script type=\"text/javascript\">
    window.location.href = window.location.href;
  </script>\n";
    }
  }
  
  protected function initialize() {
    parent::initialize();
    $this->data->fromArray($_SESSION['admin']);
    $this->title = _("Profile");
  }
  
  static public function getValidationRules() {
    $rules = array(
        "passwd"=>array("required"=>true),
        "passwd_repeat"=>array("required"=>true, "equalTo"=>"#passwd")
      );
    $messages = array(
        "passwd"=>array("required"=>_("Please enter a password")),
        "passwd_repeat"=>array("required"=>_("Please repeat the password."), "equalTo"=>_("Passwords do not match."))
      );
    
    $validationRules = new FormValidation($rules, $messages);
    return $validationRules;
  }
  
  public function getHTML(DbConnection $DB) {
?>
<form id="kdb_form" action="" method="post" enctype="multipart/form-data">
<h3 class="first"><?=_("Change password")?></h3>

<input type="hidden" id="db_admin_id" name="db_admin_id" class="id" value="<?= $this->data->db_admin_id ?>">

<p>
  <label for="passwd"><?=_("Password")?>:</label>
  <input type="password" id="passwd" name="passwd" value="">
</p>

<p>
  <label for="passwd"><?=_("Repeat password")?>:</label>
  <input type="password" id="passwd_repeat" name="passwd_repeat" value="">
</p>

<div class="form_controls_bottom">
<p>
  <input type="submit" id="kdb_save2" name="kdb_save" value="<?=_("Save")?>">
</p>
</div>
</form>
<?php
  }
}

?>