<?php
define("THIS_FILE", "setup.php");

error_reporting(E_ALL ^ E_NOTICE);
set_time_limit(600);

$cwf_path = rtrim(dirname(dirname($_SERVER['SCRIPT_FILENAME'])), '/').'/';
$cwf_http_path = rtrim(dirname(dirname($_SERVER['PHP_SELF'])), '/').'/';

define("CWF_PATH", $cwf_path);
define("CWF_HTTP_PATH", $cwf_http_path);
ini_set("include_path", CWF_PATH."cwf".PATH_SEPARATOR.CWF_PATH."k_db".PATH_SEPARATOR.CWF_PATH."admin");
define("USE_LANG", 1);
define('DEFAULT_LANG', 'de');

require_once("KDbTools.inc.php");
require_once("MainAdminUI.inc.php");
require_once("autoloader.inc.php");
autoloader::init();

CWFTools::replaceHTMLChars($_POST);
$DB = new DbConnection("", "", "", "");

$menu = new MainAdminUI($DB, false);
$ui = new KDbOptionsUI();

if(isset($_POST['kdb_submit']) && $_POST['kdb_submit']) {
  if(!$ui->saveForm($DB)) {
    $menu->setErrorMessage($ui->getErrorMessage());
  }
  else {
    require_once("../config/config.inc.php");
    $DB = new DbConnection(DB_HOST, DB_USER, DB_PASSWD, DB_NAME);
  }
}
else {
  $configFile = "../config/config.inc.php";
  if(file_exists($configFile)) {
    die("Configuration file already exists!");
  }
}

if ($menu->writeHeader(THIS_FILE, "KDb Setup", $ui->getHeader())) {
  if(!$DB->getConnectionError()) {
    DbAdmin::createTable($DB);
    DbAdminGroup::createTable($DB);
    Disclaimer::createTable($DB);
    Event::createTable($DB);
    EventOptionsGroup::createTable($DB);
    EventOption::createTable($DB);
    EventFee::createTable($DB);
    Salutation::createTable($DB);
    Country::createTable($DB);
    User::createTable($DB);
    UserBooking::createTable($DB);
    UserBookingOption::createTable($DB);
    UserBookingCheck::createTable($DB);
    View::createTable($DB);
    KDbLog::createTable($DB);
    $result = $DB->query("
      CREATE TABLE kdb_version (
        version text
      );");
    if ($result) { echo _("&nbsp;&nbsp;- creating table").": 'kdb_version'.<br>\n"; }
    else { echo _("&nbsp;&nbsp;<b>- Error when creating table</b>")." 'kdb_version'<br>\n"; $error = 1; }
    $result = $DB->query("INSERT INTO kdb_version(version) VALUES('".KDB_VERSION."');");
    
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Import data from K_Db 2
    if(isset($_POST['import_kdb2']) && $_POST['import_kdb2'] && $_POST['db_name_old']) {
      $oldDbPrefix = $_POST['db_name_old'].".".$_POST['kdb_table_prefix_old'];
      echo "<br><br>Import:<br>\n";
      //db_admin
      
      //db_admin_groups
      echo "&nbsp;&nbsp;- importiere Tabelle 'db_admin_groups'<br>\n";
      $result = $DB->query("INSERT INTO db_admin_groups(
          db_admin_group_id,
          db_admin_group_name
        ) SELECT db_admin_group_id, db_admin_group_name
          FROM {$oldDbPrefix}db_admin_groups;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      
      //disclaimers
      echo "&nbsp;&nbsp;- importiere Tabelle 'disclaimers'<br>\n";
      $result = $DB->query("INSERT INTO disclaimers(
          disclaimer_id,
          disclaimer_name
      ) SELECT disclaimer_id, description
        FROM {$oldDbPrefix}disclaimers;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      
      //events
      echo "&nbsp;&nbsp;- importiere Tabelle 'events'<br>\n";
      $result = $DB->query("INSERT INTO events (
          event_id, active, db_admin_group_id, event_name, event_title,
          event_location, event_period, event_email,
          event_description, disclaimer_id,
          allow_multiple_reg, enable_waitlist, max_abstracts, confirmation_text,
          confirmation_email, reg_email, jump2url, reg_start,
          reg_start_txt, reg_end, reg_end_txt, external_css
      ) SELECT event_id, active, db_admin_group_id, event_name, event_title,
          event_location, event_period, event_email,
          event_description, include_disclaimer,
          0, 0, max_abstracts, confirmation_text,
          confirmation_email, reg_email, jump2url, reg_start,
          reg_start_txt, reg_end, reg_end_txt, external_css
        FROM {$oldDbPrefix}events
        WHERE event_id>0;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";

      //event_forms
      //does not exist in K_Db 3
      
      //sub_event_type
      echo "&nbsp;&nbsp;- importiere Tabelle 'event_option_groups'<br>\n";
      $groups = $DB->query("SELECT event_id, st.set_id, set_name, exclusive,
                                   (SELECT required_program 
                                    FROM {$oldDbPrefix}event_forms ef
                                    WHERE ef.event_id=se.event_id) required
                            FROM {$oldDbPrefix}sub_event_type st
                              JOIN {$oldDbPrefix}sub_events se on (se.set_id=st.set_id)
                            GROUP BY event_id, set_id
                            ORDER BY event_id, subevent_id;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      $last_event = 0;
      while($group=$DB->fetch_array($groups)) {
        if($group['event_id']!=$last_event) {
          $last_event = $group['event_id'];
          $set_idx = 1;
        }
        else
          $set_idx++;
        
        if($group['required']) {
          $required = explode(", ", $group['required']);
          $is_required = (in_array($set_idx, $required) ? 1 : 0);
        }
        else 
          $is_required = 0;
        
        $result = $DB->query("INSERT INTO event_option_groups(
            event_id,
            group_name,
            group_type,
            exclusive,
            allow_changes,
            required
          ) VALUES(
            '{$group['event_id']}',
            '{$group['set_name']}',
            '".OPTION_GROUP_FEE."',
            '{$group['exclusive']}',
            0,
            '{$is_required}'
          );");
        $mapping_groups[$group['event_id']][$group['set_id']] = $DB->insert_id();
      }
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      
      //sub_events
      echo "&nbsp;&nbsp;- importiere Tabelle 'event_options'<br>\n";
      $options = $DB->query("SELECT *
                            FROM {$oldDbPrefix}sub_events
                            ORDER BY event_id, subevent_id;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      while($option=$DB->fetch_array($options)) {
        $result = $DB->query("INSERT INTO event_options(
              event_option_group_id,
              event_option,
              person_limit,
              option_type
          ) VALUES(
              '{$mapping_groups[$option['event_id']][$option['set_id']]}',
              '{$option['subevent_name']}',
              '{$option['person_limit']}',
              null
          );");
        $mapping_options[$option['subevent_id']] = $DB->insert_id();
      }
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      
      //fees
      echo "&nbsp;&nbsp;- importiere Tabelle 'event_fees'<br>\n";
      $fees = $DB->query("SELECT *
                            FROM {$oldDbPrefix}fees
                            ORDER BY subevent_id, fee_id;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      while($fee=$DB->fetch_array($fees)) {
        $result = $DB->query("INSERT INTO event_fees(
              event_option_id,
              event_fee,
              deadline
          ) VALUES(
              '{$mapping_options[$fee['subevent_id']]}',
              '{$fee['fee']}',
              '{$fee['deadline']}'
          );");
        $mapping_fees[$fee['fee_id']]['fee_id'] = $DB->insert_id();
        $mapping_fees[$fee['fee_id']]['option_id'] = $mapping_options[$fee['subevent_id']];
      }
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      
      //reg_data
      echo "&nbsp;&nbsp;- importiere Tabelle 'users'<br>\n";
      $result = $DB->query("INSERT INTO users(
          user_id,
          reg_date,
          familyname,
          givenname,
          street,
          zip_code,
          city,
          country_id,
          phone,
          fax,
          email,
          date_of_birth,
          passwd,
          gender,
          salutation_id,
          company,
          diseases_allergies,
          vegetarian,
          paramedic,
          cv_filename,
          publish_on_website,
          allow_email,
          deleted
      ) SELECT reg_id, reg_date, familyname, givenname,
          street, zip_code, city, country_id, phone,
          fax, email, date_of_birth, passwd, sex, salutation_id,
          company, diseases_allergies, vegetarian, paramedic,
          cv_filename, publish_on_website, allow_email, 0 deleted
        FROM {$oldDbPrefix}reg_data
        ORDER BY reg_id;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      
      //reg_booking
      echo "&nbsp;&nbsp;- importiere Tabelle 'user_booking'<br>\n";
      $result = $DB->query("INSERT INTO user_booking(
          booking_id,
          user_id,
          event_id,
          booking_date,
          deleted
      ) SELECT booking_id, reg_id, event_id, booking_date, 0 deleted
        FROM {$oldDbPrefix}reg_booking
        ORDER BY booking_id;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      
      //booking_check
      echo "&nbsp;&nbsp;- importiere Tabelle 'user_booking_check'<br>\n";
      $result = $DB->query("INSERT INTO user_booking_check(
          booking_id,
          payment_received,
          uploads_checked,
          has_checked_in,
          discount,
          comment
        ) SELECT booking_id, money_received, uploads_checked, 0, 
            discount, remarks
          FROM {$oldDbPrefix}reg_booking
          ORDER BY booking_id;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      
      //reg_program
      echo "&nbsp;&nbsp;- importiere Tabelle 'user_booking_options'<br>\n";
      $bookings = $DB->query("SELECT * FROM {$oldDbPrefix}reg_program ORDER BY booking_id, fee_id;");
      while($booking=$DB->fetch_array($bookings)) { 
        $result = $DB->query("INSERT INTO user_booking_options(
            booking_id,
            event_option_id,
            event_group_type,
            event_option_type,
            event_fee_id,
            value_str,
            value_num,
            value_date,
            waitlist,
            deleted
        ) VALUES(
            '{$booking['booking_id']}',
            '{$mapping_fees[$booking['fee_id']]['option_id']}',
            '".OPTION_GROUP_FEE."',
            null,
            '{$mapping_fees[$booking['fee_id']]['fee_id']}',
            null,
            null,
            null,
            0,
            0
        );");
        if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      }
    }
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // End import data from K_Db 2
  }
  else {
?>
<h2 class="first">KDb-Setup</h2>
<form id="kdb_form" action="" method="post" enctype="multipart/form-data">
<?php
  echo $ui->getHTMLnoForm();
?>

<h3><?=_("Import from KDb 2")?> <input type="checkbox" value="1" id="import_kdb2" name="import_kdb2" onClick="if($(this).attr('checked')=='checked') $('#kdb3_import').show(); else $('#kdb3_import').hide();"></h3>

<div id="kdb3_import" style="display:none;">
<p>
  <label for="db_name_old"><?=_("Database name")?>:</label>
  <input type="text" id="db_name_old" name="db_name_old" value="">
</p>
<p>
  <label for="kdb_table_prefix_old"><?=_("Table prefix")?>:</label>
  <input type="text" id="kdb_table_prefix_old" name="kdb_table_prefix_old" value="">
</p>
</div>

<div class="form_controls_bottom">
<p>
  <input type="submit" id="kdb_submit" name="kdb_submit" value="<?=_("Submit")?>">
</p>
</div>
</form>
<?php
  }
}
$menu->writeFooter();
?>
