<?php
define("THIS_FILE", "registration.php");

require_once("config/config.inc.php");
require_once("DbConnection.inc.php");
require_once("KDbTools.inc.php");
require_once("MainRegUI.inc.php");
require_once("Plugins.inc.php");
require_once("autoloader.inc.php");
autoloader::init();
include_once(CWF_PATH."plugins/plugins_admin.inc.php");

$DB = new DbConnection(DB_HOST, DB_USER, DB_PASSWD, DB_NAME);
CWFTools::startSession("k_db");
CWFTools::replaceHTMLChars($_POST);

$menu = new MainRegUI($DB);
$emailTxt = _("Dear \$givenname\$ \$familyname\$,\n\n".
              "You received this email because You used the \"forgot my password\" function. Your registration id and new password are:\n\n".
              "Your registration id: \$user_id\$\n".
              "Your new password: \$passwd\$\n\n".
              "You can log in at \$URL\$ with the new password and Your registration id or Your email address.\n\n".
              "Best regards\n\n".
              "The \$ORGANISATION_NAME\$ Team.\n");

if ($DB->getConnectionError())
  $menu->setErrorMessage($DB->getConnectionError(), 1);
else if (isset($_SESSION['user']))
  $menu->setErrorMessage(_("You are already logged in."), 1);
else if(isset($_POST['kdb_submit']) && $_POST['kdb_submit']) {
  $user = new User();
  if(preg_match('~^[0-9]+$~', $_POST['login']))
    list($errno, $error) = $user->readData($DB, "user_id='{$_POST['login']}'");
  else
    list($errno, $error) = $user->readData($DB, "lower(email)='".strtolower($_POST['login'])."'");
  
  if(!$errno && $user->id) {
    $emailTxt = str_replace(array('$URL$', '$ORGANISATION_NAME$'), array("http://".$_SERVER['SERVER_NAME'].CWF_HTTP_PATH, ORGANISATION_NAME), $emailTxt);
    $emailTxt = $user->getConfirmationText($DB, $emailTxt, 1);
    KDbTools::sendConfirmation($user->email, $emailTxt, ORGANISATION_NAME, ROOT_EMAIL);
    header("Location: index.php?message=pw_sent");
  }
  else {
    $menu->setErrorMessage($error, 0);
  }
  unset($_SESSION['reg_passwd']);
}

if ($menu->writeHeader(THIS_FILE, ORGANISATION_NAME . " - " . _("Forgotten password"), "")) {
  echo "<form id=\"kdb_form\" action=\"\" method=\"post\" enctype=\"multipart/form-data\">\n";
  echo "<div id=\"center\" class=\"login_form\">\n";
  echo "<p>"._("Please enter your registration id or your email address. We will send you a new password.")."</p>\n";
  echo "<p><label for=\"login\">"._("Registration id or email").":</label><input type=\"text\" id=\"login\" name=\"login\" value=\"\"></p>\n";
  echo "<p><input type=\"submit\" id=\"kdb_submit\" name=\"kdb_submit\" value=\""._("Submit")."\" class=\"indented\"></p>\n";
  echo "</div>\n";
  echo "</form>\n";
}
$menu->writeFooter();
?>
