//<script type="text/javascript">

function refreshHiddenColumns() {
  $('table.view th.hidden').each(function() {
    var index = $('table.view tr#headerrow th').index($(this))+1;
    kdbHideColumn(index);
  });
}

function setupTableEvents(tableSortable) {
  $(document).on('click', 'table.view tr', function() {
    if($(this).hasClass("selected"))
      $(this).removeClass("selected");
    else
      $(this).addClass("selected");
  });

  $('.filter input').keyup(throttle(function(){
    if($(this).val()!='')
      $(this).closest('div').siblings('span.showfilter').addClass("active");
    else
      $(this).closest('div').siblings('span.showfilter').removeClass("active");
    ajaxSendRequest(ajaxLoadData, $('#kdb_form_view'), "action=updateView&className="+uiClassName+"&"+$("#kdb_form_view [name^=filter]").serialize(), refreshHiddenColumns);
  }));

  if(tableSortable) {
    $('th .tableheader .th_text.sortable').on('click', function() {
      kdbSortView(uiClassName, $(this).closest('div').attr('id').replace(/^header_/, ''));
    });
  }
    
  //Hide filter dialog
  $(document).click(function(e){
    if (!$(e.target).parents().filter('th:not(#hideWhileScrolling)').length) {
      $('.filter').hide(300);
    }
    if (!$(e.target).closest('.multibuttoncontainer').length) {
      $('.multibutton').hide(300);
    }
  }); 
}

function setupTableFixedHeader() {
  var scrollingDiv1 = $("table#view .tableheader");
  var scrollingDiv2 = $("th#hideWhileScrolling div");
  $(window).scroll(function(){
    var tablePos = $("table#view").offset();
    tablePos.top = tablePos.top-$("div#content").offset().top+2;
    scrollingDiv1
      .stop()
      .animate({"top": ($(window).scrollTop()>tablePos.top ? $(window).scrollTop()-tablePos.top : 0) + "px"}, "fast" );
    scrollingDiv2
      .stop()
      .animate({"top": ($(window).scrollTop()>tablePos.top ? $(window).scrollTop()-tablePos.top : 0) + "px"}, "fast" );
  });
}

function kdbUpdateViewTable(className, formName, addFields) {
  var addFieldsStr="";
  if(typeof(addFields)!="undefined") addFieldsStr=addFields+"&";
  ajaxSendRequest(ajaxLoadData, $('#'+formName),  "action=updateView&className="+className+"&"+addFieldsStr+$("#"+formName+" [name^=select]").serialize(), refreshHiddenColumns);
}

function kdbActionConfirmation(className, formName, dialog) {
  addParams = "";
  switch(dialog) {
    case "dialog_email":
      if($("#"+formName+" [name^=select]:checked").length==0) {
        alert(ajaxNoRecipients);
        return false;
      }
      addParams = "email=1&";
      break;
    case "dialog_merge":
      selectMergeWith = $("div#dialog_merge select#merge_with_id");
      $('option', selectMergeWith).remove();
      $('input[name^=select_user_id]:checked').each(function() {
        selectMergeWith.append("<option>"+$(this).val()+"</option>");
      });
      break;
  }
  ajaxSendRequest(ajaxLoadData, $('#'+formName),  "action=updateView&className="+className+"&kdb_selected=1&"+addParams+$("#"+formName+" [name^=select]").serialize(), refreshHiddenColumns);
  $("form#kdb_form_view div.form_controls_top").hide();
  $("form#kdb_form_view div.form_controls_bottom").hide();
  $("div#"+dialog).show();
}

function kdbCancelAction(className, formName, dialog) {
  ajaxSendRequest(ajaxLoadData, $('#'+formName), "action=updateView&className="+className+"&"+$("#"+formName+" [name^=select]").serialize(), refreshHiddenColumns);
  $("div#"+dialog).hide();
  $("form#kdb_form_view div.form_controls_top").show();
  $("form#kdb_form_view div.form_controls_bottom").show();
}

function kdbLoadEmailTemplate(className, formName) {
  ajaxSendRequest(ajaxLoadData, $('#'+formName), "action=loadTemplate&className="+className+"&"+$("#"+formName+" [name=email_template_id]").serialize());
}
function kdbSaveEmailTemplate(className, formName) {
  ajaxSendRequest(ajaxSaveData, $('#'+formName), "action=saveTemplate&className="+className+"&"+$("#"+formName+" [name^=email_]").serialize());
}
function kdbDeleteEmailTemplate(className, formName) {
  ajaxSendRequest(ajaxDeleteData, $('#'+formName), "action=deleteTemplate&className="+className+"&"+$("#"+formName+" [name^=email_template_]").serialize());
}

function kdbActionDo(className, formName, dialog) {
  if(typeof(formName)=="undefined") formName = 'kdb_form';
  switch(dialog) {
    case "dialog_email":
      if($('#'+formName+' #email_attachment').val()!="") {
        return false;
      }
      text = ajaxSendEmails;
      post = "action=sendEmail&className="+className+"&"+$("#"+formName+" [name^=email_], #"+formName+" [name^=select]").serialize();
      break;
    case "dialog_merge":
      text = ajaxSaveData;
      post = "action=merge&className="+className+"&"+$("#"+formName+" [name^=select], #"+formName+" select#merge_with_id").serialize();
      break;
    case "dialog_delete":
      text = ajaxDeleteData;
      post = "action=delete&className="+className+"&"+$("#"+formName+" [name^=select]").serialize();
      break;
  }
  ajaxSendRequest(text, $('#'+formName), post, refreshHiddenColumns);
  $("div#"+dialog).hide();
  $("form#kdb_form_view div.form_controls_top").show();
  $("form#kdb_form_view div.form_controls_bottom").show();
  return true;
}

function kdbGetCSV(className, formName) {
  window.location.href="../index.php/get_csv";
}

function kdbUpdateViewDialog(user_id, booking_id, update_booking) {
  $('#kdb_form_user').cwfClearForm();
  $('#kdb_form_booking').cwfClearForm();
  if(typeof(user_id)!="undefined")
    kdbUpdateDialog(user_id, 'UserUI', 'kdb_form_user');
  if(typeof(booking_id)!="undefined" && update_booking)
    kdbUpdateDialog(booking_id, 'UserBookingUI', 'kdb_form_booking');
  $('#dialog_view').show();
}

function kdbViewSelectAll(checkbox) {
  if(checkbox.attr('checked')=='checked')
    $('*[name^=select]').attr('checked', 'checked');
  else
    $('*[name^=select]').removeAttr('checked');
}

function kdbSortView(className, column) {
  $(".tableheader").each(function() {
    if($(this).attr("id")=="header_"+column && $(".th_text", $(this)).hasClass("sort_ascending"))
      $(".th_text", $(this)).removeClass("sort_ascending").addClass("sort_descending");
    else if ($(this).attr("id")=="header_"+column)
      $(".th_text", $(this)).removeClass("sort_descending").addClass("sort_ascending");
    else
      $(".th_text", $(this)).removeClass("sort_descending").removeClass("sort_ascending");
  });
  ajaxSendRequest(ajaxLoadData, $('#kdb_form_view'), {"action": "updateView", "sortby": column, "className": className}, refreshHiddenColumns);
}

function storeHiddenColumns(viewId, element, hide) {
  if(viewId) {
    if (hiddenColumns = sessionStorage.getItem("hiddenColumns_"+viewId))
      hiddenColumns = hiddenColumns.split(";");
    else
      hiddenColumns = new Array();
    var pos=$.inArray(element.toString(), hiddenColumns);
    if(pos>=0 && !hide) {
      hiddenColumns.splice(pos, 1);
    }
    else if (pos<0 && hide) {
      hiddenColumns.push(element);
    }
    sessionStorage.setItem("hiddenColumns_"+viewId, hiddenColumns.join(";"));
  }
}

function kdbHideColumn(columnIndex, element) {
  if(typeof(element)=="undefined" || !element.hasClass('disabled')) {
    if(typeof(element)!="undefined") element.addClass('disabled');
    $('table#view th:nth-child('+columnIndex+')').addClass('hidden').hide();
    $('table#view td:nth-child('+columnIndex+')').addClass('hidden').hide();
    storeHiddenColumns(viewId, columnIndex, true);
  }
  else {
    element.removeClass('disabled');
    $('table#view th:nth-child('+columnIndex+')').removeClass('hidden').show();
    $('table#view td:nth-child('+columnIndex+')').removeClass('hidden').show();
    storeHiddenColumns(viewId, columnIndex, false);
  }
}

function kdbShowTableFilter(filterElement) {
  $('.filter').hide(300);
  var filter = filterElement.closest('div.tableheader').children('div.filter');
  if(filter.is(':visible')) 
    filter.hide(300); else filter.show(300);
}

var viewId;

$(document).ready(function(){
  if($('table.view').outerWidth()>=$('div#content').innerWidth())
    $('div#content').css('right', 'auto');
});

//</script>